<template>
    <div>
        <crumbs title="组合填写单维护" class="simpleQ-crumb">
            <el-form :inline="true" class="demo-form-inline">
                <el-form-item label="归属：">
                    <el-select size="mini" v-model="filter.tagAdscription"  placeholder="归属" clearable>
                        <el-option v-if="item.val!=6&&item.val!=7&&item.val!=8&&item.val!=9&&item.val!=10&&item.val!=21&&item.val!=22" v-for="item in Adscriptions" :label="item.name" :value="item.val" :key="item.id" ></el-option>
                    </el-select>
                </el-form-item>
                <el-form-item label="类型：">
                    <el-select size="mini" v-model="filter.tagType[0]" placeholder="类型" clearable>
                        <el-option v-for="item in tagTypes" :label="item.name" :value="item.val" :key="item.id"></el-option>
                    </el-select>
                </el-form-item>
                <el-form-item label="填写单系统名称：">
                    <el-input size="mini" v-model="filter.tagSysName" placeholder="填写单系统名称" clearable></el-input>
                </el-form-item>
                <el-form-item label="填写单医生界面名称：">
                    <el-input size="mini" v-model="filter.name" placeholder="填写单医生界面名称" clearable></el-input>
                </el-form-item>
                <el-form-item>
                    <el-button size="mini" @click="filterDatas">确认</el-button>
                    <el-button size="mini" type="warning" @click="addIndeptTag">添加组合填写单</el-button>
                </el-form-item>
            </el-form>
        </crumbs>
        <div class="contents simpleQ-contents">
            <el-table
                    :data="list"
                    border
                    style="width: 100%">
                <el-table-column
                        :resizable = "false"
                        type="index"
                        :index = 'indexMethod'
                        label="编号"
                        width="60">
                </el-table-column>
                <el-table-column
                        :resizable = "false"
                        prop="gmtModified"
                        label="操作时间"
                        width="180">
                </el-table-column>
                <el-table-column
                        :resizable = "false"
                        prop="tagName"
                        label="填写单系统名称">
                </el-table-column>
                <el-table-column
                        :resizable = "false"
                        prop="name"
                        label="填写单医生界面名称">
                </el-table-column>
                <el-table-column
                        :resizable = "false"
                        prop="typeCn"
                        label="归属"
                        width="80">
                </el-table-column>
                <el-table-column
                        :resizable = "false"
                        prop="tagTypeCn"
                        label="类型">
                </el-table-column>
                <el-table-column
                        :resizable = "false"
                        prop="modifier"
                        label="操作人"
                        width="120">
                </el-table-column>
                <el-table-column
                        :resizable = "false"
                        prop="operate"
                        label="操作"
                        width="140">
                    <template slot-scope="scope">
                        <el-button  @click="modifyIndeptTag(scope.row)" type="text" size="small">修改</el-button>
                        <span style="margin:0 3px;">|</span>
                        <el-button  @click="modifyIndeptTag(scope.row,true)" type="text" size="small">复制</el-button>
                        <span style="margin:0 3px;">|</span>
                        <el-button @click="showDelDialog(scope.row)" class="delete" type="text" size="small">删除</el-button>
                    </template>
                </el-table-column>
            </el-table>
            <el-pagination :current-page.sync="currentPage"
                           @current-change="currentChange"
                           background
                           :page-size="pageSize"
                           :page-sizes="pageSizeArr"
                           @size-change="handleSizeChange"
                           :layout="pageLayout"
                           :total="total">
            </el-pagination>
        </div>
    </div>
</template>

<script>
  import api from '@api/preTreat.js';
  import config from '@api/config.js';
  import utils from '@api/utils.js';

  export default {
    name: 'combinQuestion',
    data: function() {
      return {
        list: [],
        tagTypes: [],
        Adscriptions: [],
        tagTypesList:[],
        searched:false,
        filter: {
          tagType: [], //标签类型
          tagAdscription: '', //标签归属
          tagSysName: '', //标签系统名称
          name:'',          //界面名称
        },
        currentPage: 1,
        pageSize: config.pageSize,
        pageSizeArr:config.pageSizeArr,
        pageLayout:config.pageLayout,
        total: 0,
      }
    },
    created() {
      this.getDropList();
    },
    watch:{
      'filter':{
        handler:function(){
          this.searched = false;
        },
        deep:true
      }
    },
    beforeRouteEnter(to, from, next){
      next(vm => {
        //const pm = to.param;
        Object.assign(vm,to.params);
        vm.inCurrentPage=to.params.currentPage;
      })
    },
    methods: {
      handleSizeChange(val){
        this.pageSize = val;
        this.currentPage = utils.getCurrentPage(this.currentPage, this.total, this.pageSize);
        this.getDataList();
      },
      getDropList() {
        api.getPreTypeList().then((res) =>{
          this.getDataList();
          if(res.data.code === '0') {
            this.Adscriptions = res.data.data[1];
            this.tagTypes =  res.data.data[3];
            this.tagTypes =  this.tagTypes.filter(item => item.val != 0)  //去掉名称为默认值的填写单类型

          }

        })
      },
      getDataList(isTurnPage) {
        const param = this.getFilterItems(isTurnPage);
        this.searched = true;
        const loading = this.$loading({
            lock: true,
            text: 'Loading',
            spinner: 'el-icon-loading',
            background: 'rgba(0, 0, 0, 0.7)'
        });
        api.getQuestionList(param).then((res) => {
          loading.close()
          const list = [...res.data.data.records];
          for (var i = 0; i < list.length; i++) {
            for (var j =  0; j < this.tagTypes.length; j++) {
              if(list[i].tagType == this.tagTypes[j].val) {
                list[i].tagTypeCn = this.tagTypes[j].name;
              }
            }
            //后台数据typeCn转换为筛选中对应的字段名称
            for (var z =  0; z < this.Adscriptions.length; z++) {
              if(list[i].type == this.Adscriptions[z].val) {
                list[i].typeCn = this.Adscriptions[z].name;
              }
            }
          }
          this.list = list;
          this.total = res.data.data.total;
          if(this.inCurrentPage!==undefined){
            this.currentPage=this.inCurrentPage;
            this.inCurrentPage = undefined;
          }
        })
      },
      filterDatas() {
        this.currentPage = 1;
        this.getDataList();
      },
      addIndeptTag() {
        const pam = this.searched?{currentPage:this.currentPage,
          pageSize:this.pageSize,
          filter:this.filter}:{currentPage:this.currentPage,
          pageSize:this.pageSize};
        this.$router.push({name:'AddCombinQuestion',
          params:pam});
      },
      modifyIndeptTag(row,isCopy) {
        api.questionDetail({id:row.id}).then((res)=>{
          const {code,data,msg} = res.data;
          if(code=='0'){
            const infos = Object.assign({},row,data);
            const pam = this.searched?{currentPage:this.currentPage,
              pageSize:this.pageSize,
              filter:this.filter}:{currentPage:this.currentPage,
              pageSize:this.pageSize};
            this.$router.push({name:'AddCombinQuestion',params:Object.assign(pam,{[isCopy?'isCopy':'isEdit']:true,data:infos})});
          }else{
            this.$message({
              message: msg,
              type: 'warning'
            });
          }
        });
      },
      currentChange(next) {
        this.currentPage = next;
        this.getDataList(true);
      },
      getFilterItems(isTurnPage) {
        //翻页时筛选条件没点确定则清空
        if(isTurnPage&&!this.searched){
          this.clearfilter();
        };
        let param = {
          tagTypeList: this.filter.tagType[0] ? this.filter.tagType: [4,6],
          current: this.inCurrentPage||this.currentPage,
          callType:2,
          size: this.pageSize,
          type: this.filter.tagAdscription,
          tagName: this.filter.tagSysName.trim(),
          name:this.filter.name.trim(),          //界面名称
        };
        return param;
      },
      clearfilter(){
        this.filter={
          tagType: [], //标签类型
          tagAdscription: '', //标签归属
          tagSysName: '', //标签系统名称
          name:'',          //界面名称
        };
      },
      indexMethod(index) {
        return ((this.currentPage - 1) * this.pageSize) + index + 1;
      },
      getTagType(val) {
        return val
      },
      warning(msg,type){
        this.$message({
          showClose: true,
          message:msg,
          type:type||'warning'
        })
      },
      showConfirmDialog(msg,resolve){
        this.$alert(msg, '提示', {
          confirmButtonText: '确定',
          type: 'warning'
        }).then(() => {
          resolve();
        }).catch(() => {});
      },
      showDelDialog(row){
        const param = {
          "ids": row.id,
          "type": row.type
        };
        this.showConfirmDialog('是否删除该填写单？',()=>{
          api.questionDel(param).then((res)=>{
            if(res.data.code=='0'){
              if(!this.searched){
                //未点确认时清空搜索条件
                this.clearfilter();
              }
              if(this.list.length==1){
                //当前在最后一页且只有一条数据时，删除后跳到前一页
                this.currentPage = this.currentPage===1?1:this.currentPage-1;
              }
              this.getDataList();
              this.warning(res.data.msg || '操作成功','success');
            }else{
              this.warning(res.data.msg);
            }
          }).catch((error)=>{
            this.warning(error);
          })
        });
      }
    }
  }
</script>


<style lang="less">
    @import "../../less/admin.less";
    .delete{
        color: red
    }
    .delete:hover {
        color: red;
    }
    .el-select .el-input .el-icon-arrow-up{
        display: inline-block!important;
    }
    .el-select .el-input .el-icon-circle-close{
        float:left;
    }
</style>